// ==UserScript==
// @name         StopAddonUpadate
// @namespace    
// @description  Adds stop update someone extension popup menu in Add-on Manager.
// @include      chrome://mozapps/content/extensions/extensions.xul
// @author       knarf32222
// @version      1.0.20090207
// @homepage     
// ==/UserScript==
var UI = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
UI.charset = "UTF-8";

var StopAddonUpadate = {

	init: function()
	{
		document.getElementById("addonContextMenu").addEventListener("popupshowing", this, false);
	},

	set: function(setValue)
	{
		var selectedItem = gExtensionsView.selectedItem;
		var addonID = selectedItem.getAttribute("addonID");
   	var prefService = Components.classes[ "@mozilla.org/preferences-service;1" ]
                               .getService( Components.interfaces.nsIPrefBranch );
		prefService.setBoolPref( "extensions."+addonID+".update.enabled", !setValue );
	},

	handleEvent: function(event)
	{
		var popup = event.target;
		var selectedItem = gExtensionsView.selectedItem;
		var addonID = selectedItem.getAttribute("addonID");
   	var prefService = Components.classes[ "@mozilla.org/preferences-service;1" ]
                               .getService( Components.interfaces.nsIPrefBranch );
		var isSet = false;
		try{
			var update = prefService.getBoolPref( "extensions."+addonID+".update.enabled");
			isSet = true;
		}catch(e){}

		if(!isSet) update = true;

		var menuitem = document.createElement("menuitem");

		if(!update) menuitem.setAttribute("label", UI.ConvertToUnicode("允許自動更新該套件"));
		else 	menuitem.setAttribute("label", UI.ConvertToUnicode("停止自動更新該套件"));

		menuitem.setAttribute("oncommand", "StopAddonUpadate.set("+update+");");
		popup.insertBefore(menuitem, document.getElementById("menuitem_homepage_clone"));
	}

};

StopAddonUpadate.init();
